/* 
DC Stepper Motor Control
Author: Kathryn Rooney
November-December 2017
*/

#include <Wire.h>
#include <Adafruit_MotorShield.h>
#include "utility/Adafruit_MS_PWMServoDriver.h"
#include <SoftwareSerial.h>

// Create the motor shield object with the default I2C address
Adafruit_MotorShield AFMS = Adafruit_MotorShield(); 

// Connect a stepper motor with 200 steps per revolution (1.8 degree)
// to motor port #2 (M3 and M4)
Adafruit_StepperMotor *myMotor = AFMS.getStepper(200, 2);

//**********************USER INPUT**********************
// Is your plate a 384 well or 96 well size?
int platesize = 384;
// How many columns must be filled?
int columns = 12;
//How many rows must be filled?
int rows = 5;
//How much liquid must be dispensed, in microliters?
int volume = 20;
//*******************************************************

// Establish variables
int counter = 0;
int numSteps = 8; //steps required to move plate down one row
int rowTime; //establish variable for time required for one row to fill, in seconds


void setup() {
  Serial.begin(9600); // set up Serial library at 9600 bps
  AFMS.begin();  // create with the default frequency 1.6KHz
  myMotor->setSpeed(10);  // 10 rpm
  

if (platesize == 384) {
  if (columns == 1) {
    rowTime = 0.016*(volume) + 2.400;
  }
  if (columns == 2) {
    rowTime = 0.032*(volume) + 3.452;
  }
  if (columns == 3) {
    rowTime = 0.042*(volume) + 3.975;
  }
  if (columns == 4) {
    rowTime = 0.055*(volume) + 4.480;
  }
  if (columns == 5) {
    rowTime = 0.068*(volume) + 5.032;
  }
  if (columns == 6) {
    rowTime = 0.083*(volume) + 5.536;
  }
  if (columns == 7) {
    rowTime = 0.094*(volume) + 6.242;
  }
  if (columns == 8) {
    rowTime = 0.109*(volume) + 6.580;
  }
  if (columns == 9) {
    rowTime = 0.118*(volume) + 7.078;
  }
  if (columns == 10) {
    rowTime = 0.132*(volume) + 7.604;
  }
  if (columns == 11) {
    rowTime = 0.146*(volume) + 7.928;
  }
  if (columns == 12) {
    rowTime = 0.159*(volume) + 8.436;
  }
  if (columns == 13) {
    rowTime = 0.179*(volume) + 8.603;
  }
  if (columns == 14) {
    rowTime = 0.184*(volume) + 9.295;
  }
  if (columns == 15) {
    rowTime = 0.197*(volume) + 9.586;
  }
  if (columns == 16) {
    rowTime = 0.210*(volume) + 10.095;
  }
  if (columns == 17) {
    rowTime = 0.222*(volume) + 10.419;
  }
  if (columns == 18) {
    rowTime = 0.236*(volume) + 10.625;
  }
  if (columns == 19) {
    rowTime = 0.253*(volume) + 10.755;
  }
  if (columns == 20) {
    rowTime = 0.265*(volume) + 11.214;
  }
  if (columns == 21) {
    rowTime = 0.274*(volume) + 11.510;
  }
  if (columns == 22) {
    rowTime = 0.287*(volume) + 11.893;
  }
  if (columns == 23) {
    rowTime = 0.304*(volume) + 12.006;
  }
  if (columns == 24) {
    rowTime = 0.321*(volume) + 12.308;
  }
}

if (platesize == 96) {
  if (columns == 1) {
    rowTime = 0.013*(volume) + 1.652;
  }
  if (columns == 2) {
    rowTime = 0.014*(volume) + 2.782;
  }
  if (columns == 3) {
    rowTime = 0.022*(volume) + 3.460;
  }
  if (columns == 4) {
    rowTime = 0.026*(volume) + 3.935;
  }
  if (columns == 5) {
    rowTime = 0.034*(volume) + 4.398;
  }
  if (columns == 6) {
    rowTime = 0.041*(volume) + 5.087;
  }
  if (columns == 7) {
    rowTime = 0.046*(volume) + 5.605;
  }
  if (columns == 8) {
    rowTime = 0.053*(volume) + 6.146;
  }
  if (columns == 9) {
    rowTime = 0.060*(volume) + 6.876;
  }
  if (columns == 10) {
    rowTime = 0.069*(volume) + 7.374;
  }
  if (columns == 11) {
    rowTime = 0.074*(volume) + 7.897;
  }
  if (columns == 12) {
    rowTime = 0.080*(volume) + 8.206;
  }
}
}

void loop() {
  if (counter < rows) {
//    Serial.print(rowTime);
    delay(1000*rowTime);
    myMotor->step(numSteps, FORWARD, DOUBLE); 
    delay(2000);
    Serial.write(0x56); //V
    Serial.print(volume); //volume
    Serial.write(0x0A); //LF
    Serial.write(0x44); //D
    Serial.write(0x0A); //LF

  if (platesize = 96) {
    counter = counter + 1;
  }
  else if (platesize = 384) {
    counter = counter + 2;
  } 
  }
  else if (counter == rows) {
    myMotor->step(24, FORWARD, DOUBLE);
  }
}

